<?
/*   cat_ed.php v.1.5 for UdmSearch engine
 *   (C) 2000 by Sergey Kartashoff <gluke@biosys.net>,
 *                          UdmSearch Developers Team
 */
?>

<html>
<body bgcolor=#888888>
<font face="arial,helvetica">

<script language="JavaScript">

function test(x,y) {
    if (confirm("Sure?")) {window.location.href=x}
    else {window.location.href=y} 
}

</script>

<?                        
   require('config.inc');      
   require('db_func.inc');

// -----------------------------------------------------
//  print_error_local($msg)
// -----------------------------------------------------
function print_error_local($msg) {
        global $PHP_SELF;
   	print "<center><font FACE=\"Arial, Helvetica\" color=#d00000 size=+2><b>Error: </b></font><font FACE=\"Arial, Helvetica\" size=+2>$msg</font></center><br>\n";
   	exit;
}

// -----------------------------------------------------
//  get_new_path($path)
// -----------------------------------------------------
function get_new_path($path) {
        global $DEBUG;
	global $fill;
	global $path_base;

	$query="SELECT path
       	          FROM categories
                 WHERE path LIKE '$path"."__'"."
                   AND path NOT LIKE '$path"."@@'
                 ORDER BY path ASC";

	if($DEBUG) echo $query,"<BR><HR>";

        if (!($res=query($query))) {
   		print_error_local("Query error:".db_error($res));
   	}

   	if (!$fill) {
   		$new_path='00';
   		while ($row=fetch_row($res)) {
   			$temp=strtoupper(base_convert(substr($row[0],strlen($row[0])-2,2),$path_base,10));
   			if ($new_path < $temp) $new_path=$temp;
   		} // while
                $new_path=base_convert($new_path+1,10,$path_base);
   	} else {
   		$new_path=1;
   		while ($row=fetch_row($res)) {
   			$temp=strtoupper(base_convert(substr($row[0],strlen($row[0])-2,2),$path_base,10));
   			if ($temp > $new_path) break;
   			else $new_path++;
   		} // while
                $new_path=base_convert($new_path,10,$path_base);
   	} // if 

   	free_result($res);

   	if (strlen($new_path)==1) $new_path='0'.$new_path;

   	$new_path = strtoupper($path.$new_path);
   	return($new_path);
}

// -----------------------------------------------------
//  optimize_tree($path)
// -----------------------------------------------------
function optimize_tree($path) {
        global $DEBUG;
	global $path_base;
	
        $query="SELECT path
                  FROM categories
                 WHERE path LIKE '$path"."__'"."
                   AND path NOT LIKE '$path"."@@'
                 ORDER BY path";

	if($DEBUG) echo $query,"<BR><HR>";

        if (!($res=query($query))) {
   		print_error_local("Query error:".db_error($res));
   	}

   	$new_path=1;

   	while ($row=fetch_row($res)) {
   		if (get_link_count($row[0])) optimize_tree($row[0]);

   		$temp_16=strtoupper(substr($row[0],strlen($row[0])-2,2));
                $temp=base_convert($temp,$path_base,10);

   		if ($new_path != $temp) {
   			$new_path_16=strtoupper(base_convert($new_path,10,$path_base));

   			if (strlen($new_path_16)==1) $new_path_16='0'.$new_path_16;
                        if (strlen($temp_16)==1) $temp_16='0'.$temp_16;

   			$query="SELECT rec_id,
   			               path
 			          FROM categories
   			         WHERE path LIKE '$path$temp_16%'";
				 
			if($DEBUG) echo $query,"<BR><HR>";		 

                        if (!($res2=query($query))) {
   				print_error_local("Query error:".db_error($res2));
   			}

   			while($row2=fetch_row($res2)) {
   				$rec_id=$row2[0];
   				$old_path=$row2[1];

   				$new_path_to_insert=strtoupper(eregi_replace("^$path$temp_16","$path$new_path_16",$old_path));
   				
				
   				$query="UPDATE categories
   				           SET path='$new_path_to_insert'
   				         WHERE rec_id=$rec_id";
					
				if($DEBUG) echo $query,"<BR><HR>";	
				
				if (!($temp_res=query($query))) {
   				    print_error_local("Query error:".db_error($temp_res));
   				}

                                $query="UPDATE categories
   				           SET link='$new_path_to_insert'
   				         WHERE link='$old_path'";
					
				if($DEBUG) echo $query,"<BR><HR>";	
				
				if (!($temp_res=query($query))) {
   				    print_error_local("Query error:".db_error($temp_res));
   				}					
   			}

   			free_result($res2);
   		}

   		$new_path++;
   	}
   	free_result($res);
}


// -----------------------------------------------------
//  get_link_count($path)
// -----------------------------------------------------
function get_link_count($path) {
	global $DEBUG;
	
        $query="SELECT count(*)
                  FROM categories
                 WHERE path LIKE '$path"."__'";

	if($DEBUG) echo $query,"<BR><HR>";	
				
        if (!($res2=query($query))) {
   		print_error_local("Query error:".db_error($res2));
   	}

   	$row2=fetch_row($res2);
   	free_result($res2);

   	return($row2[0]);
}

// -----------------------------------------------------
//  get_link_name($link)
// -----------------------------------------------------
function get_link_name($link) {
	global $DEBUG;

   	$link_path=$link;
   	$link_name='';

   	while ($link_path!='') {
   		$query="SELECT name FROM categories WHERE path='$link_path'";
		
		if($DEBUG) echo $query,"<BR><HR>";	

                if (!($res=query($query))) {
   			print_error_local("Query error:".db_error($res));
   		}

   		$row=fetch_row($res);
   		free_result($res);

   		if (!$row) {
   			$link_path=substr($link_path,0,strlen($link_path)-2);
   			continue;
   		}

   		$link_name = " / $row[0]".$link_name;

   		$link_path=substr($link_path,0,strlen($link_path)-2);
   	}

   	$query="SELECT name FROM categories WHERE path='' OR path IS NULL";
	
	if($DEBUG) echo $query,"<BR><HR>";	

        if (!($res=query($query))) {
  		print_error_local("Query error:".db_error($res));
  	}

  	$row=fetch_row($res);
  	free_result($res);

  	if ($row) {
  		$link_name = " / $row[0]".$link_name;
  	} else {
  		$link_name='';
  	}

   	return $link_name;
}

// -----------------------------------------------------
//  get_link_href_name($link)
// -----------------------------------------------------
function get_link_href_name($link) {
   	global $PHP_SELF;
        global $sort;
	global $DEBUG;

   	$link_path=$link;
   	$link_name='';

   	while ($link_path!='') {
   		$query="SELECT name FROM categories WHERE path='$link_path'";
		
		if($DEBUG) echo $query,"<BR><HR>";	

                if (!($res=query($query))) {
   			print_error_local("Query error:".db_error($res));
   		}

   		$row=fetch_row($res);
   		free_result($res);

   		if (!$row) {
   			$link_path=substr($link_path,0,strlen($link_path)-2);
   			continue;
   		}

   		$row[0]=htmlspecialchars($row[0]);
   		$link_name = " / <a href=\"$PHP_SELF?sel_path=$link_path&sort=$sort\">$row[0]</a>".$link_name;

   		$link_path=substr($link_path,0,strlen($link_path)-2);
   	}

   	$query="SELECT name FROM categories WHERE path='' OR path IS NULL";

	if($DEBUG) echo $query,"<BR><HR>";	

        if (!($res=query($query))) {
  		print_error_local("Query error:".db_error($res));
  	}

  	$row=fetch_row($res);
  	free_result($res);

  	if ($row) {
  		$row[0]=htmlspecialchars($row[0]);	
  		$link_name = " / <a href=\"$PHP_SELF?sel_path=&sort=$sort\">$row[0]</a>".$link_name;
  	} else {
  		$link_name='';
  	}

   	return $link_name;
}

// -----------------------------------------------------
//  M A I N
// -----------------------------------------------------

   initdb();
   
   if (($path_base<9) || ($path_base>36)) $path_base=16;

   $sel_path=urldecode($sel_path);
   $old_path=urldecode($old_path);

   $sel_path=trim($sel_path);
   $old_path=trim($old_path);
   $new_path=trim($new_path);
   $new_name=trim($new_name);

   if ($sort=='') $sort='name';

   if ($action=='del') {
   	$query="DELETE FROM categories
   	         WHERE path LIKE '$sel_path%'";
		
	if($DEBUG) echo $query,"<BR><HR>";		
	
        if (!($res=query($query))) {
  		print_error_local("Query error:".db_error($res));
  	}
		
        $query="DELETE FROM categories
   	        WHERE link LIKE '$sel_path%'";

	if($DEBUG) echo $query,"<BR><HR>";		
	
        if (!($res=query($query))) {
  		print_error_local("Query error:".db_error($res));
  	}

   	$sel_path=substr($sel_path,0,strlen($sel_path)-2);
   } elseif ($action == 'rename') {
   	$query="UPDATE categories
   	           SET name='$new_name'
   	         WHERE path='$old_path'";
		
	if($DEBUG) echo $query,"<BR><HR>";		
	
        if (!($res=query($query))) {
  		print_error_local("Query error:".db_error($res));
  	}
   } elseif ($action == 'edit_link') {
        if ($new_path != '') {
    	    $query="SELECT count(*)
                      FROM categories
                     WHERE path='$new_path'";
	} else {
    	    $query="SELECT count(*)
            	      FROM categories
                     WHERE path='$new_path'
		        OR path IS NULL";
	}
	if($DEBUG) echo $query,"<BR><HR>";	
	
        if (!($res2=query($query))) print_error_local("Query error:".db_error($res2));

        $row2=fetch_row($res2);
        if ($row2[0]) {
   		$query="UPDATE categories
   	          	   SET link='$new_path'
   	                 WHERE path='$old_path'";
			 
		if ($DEBUG) echo $query,"<BR><HR>";		
	
    		if (!($res=query($query))) {
  		    print_error_local("Query error:".db_error($res));
  		}
   	} else {
   		print "WARNING : INVALID LINK DESTINATION ENTERED. PLEASE RETRY.<br>\n";
   	}
   } elseif ($action == 'optimize') {
   	optimize_tree('');
   } elseif ($action == 'new_cat') {
   	$query="SELECT count(*)
                  FROM categories";
		  
	if ($DEBUG) echo $query,"<BR><HR>";			  
	
        if (!($res2=query($query))) print_error_local("Query error:".db_error($res2));

        $row2=fetch_row($res2);
        if (!$row2[0]) {
	    if (($dbtype == 'oracle') || ($dbtype == 'oracle7') || ($dbtype == 'oracle8')) {
		$query="INSERT INTO categories (rec_id,path,link,name)
   	       	        VALUES ( SQ_category_id.nextval, '', '','$root_name')";
			
		if ($DEBUG) echo $query,"<BR><HR>";			  
	
    		if (!($res=query($query))) print_error_local("Query error:".db_error($res));
	    } else {
        	$query="INSERT INTO categories (path,link,name)
   	       	        VALUES ( '', '','$root_name')";
			
		if ($DEBUG) echo $query,"<BR><HR>";			  
	
    		if (!($res=query($query))) print_error_local("Query error:".db_error($res));
	    }		       
        }

        free_result($res2);

   	$new_path=get_new_path($sel_path);
	
	if (($dbtype == 'oracle') || ($dbtype == 'oracle7') || ($dbtype == 'oracle8')) {
   	    $query="INSERT INTO categories (rec_id,path,link,name)
   	            VALUES ( SQ_category_id.nextval, '$new_path', '','$new_cat')";
	} else {
   	    $query="INSERT INTO categories (path,link,name)
   	            VALUES ( '$new_path', '','$new_cat')";
	}
	if ($DEBUG) echo $query,"<BR><HR>";			  
	
    	if (!($res=query($query))) print_error_local("Query error:".db_error($res));
   } elseif ($action == 'new_link') {
   	$query="SELECT count(*)
                  FROM categories";
		  
	if ($DEBUG) echo $query,"<BR><HR>";			  	  
		  
        if (!($res2=query($query))) print_error_local("Query error:".db_error($res2));

        $row2=fetch_row($res2);
	
        if (!$row2[0]) {
	    if (($dbtype == 'oracle') || ($dbtype == 'oracle7') || ($dbtype == 'oracle8')) {
		$query="INSERT INTO categories (rec_id,path,link,name)
    	       	        VALUES ( SQ_category_id.nextval, '', '','$root_name')";
	    } else {
        	$query="INSERT INTO categories (path,link,name)
   	       	        VALUES ( '', '','$root_name')";
	    }		       
	    if ($DEBUG) echo $query,"<BR><HR>";			  	  
		  
    	    if (!($res=query($query))) print_error_local("Query error:".db_error($res));
        }

        free_result($res2);

	if (($dbtype == 'oracle') || ($dbtype == 'oracle7') || ($dbtype == 'oracle8')) {
   	    $query="INSERT INTO categories (rec_id,path,link,name)
    	            VALUES ( SQ_category_id.nextval, '$sel_path@@','','$new_link')";
	} else {
   	    $query="INSERT INTO categories (path,link,name)
   	            VALUES ( '$sel_path@@','','$new_link')";
	}
	if ($DEBUG) echo $query,"<BR><HR>";			  	  
		  
    	if (!($res=query($query))) print_error_local("Query error:".db_error($res));
   }

   if ($sort=='path') $sql_sort='ORDER BY path ASC,link ASC';
   elseif ($sort=='name') $sql_sort='ORDER BY name ASC';
   $query="SELECT path,
                  link,
                  name
             FROM categories
            WHERE path LIKE '$sel_path"."__'"."
            $sql_sort";
	    
   if ($DEBUG) echo $query,"<BR><HR>";			  	  	    

   if (!($res=query($query))) print_error_local("Query error:".db_error($res));

   $cur_path=get_link_href_name($sel_path);

?>

<table border=1 cellspacing=0 cellpadding=3 width=100%>

<tr bgcolor=#dddddd>
<td align=center><a href=<? echo $PHP_SELF; ?>><font size=+1><b>< Go to begin ></b></font></td>
<td align=center><a href=<? echo "$PHP_SELF?action=optimize&sel_path=$sel_path&sort=$sort"; ?>><font size=+1><b>< Tree optimization (slow) > </b></font></td>
<td align=center>&nbsp;</td>
</tr>

<form action=<? echo $PHP_SELF ?> method=post>

<tr bgcolor=#7070af>
<td><font color=#FFFFFF><b>New category</b></font></td>
<td><input type=text size=40 name=new_cat>
    <input type=hidden name=sel_path value="<? echo $sel_path; ?>">
    <input type=hidden name=sort value="<? echo $sort; ?>">
    <input type=hidden name=action value="new_cat">
    </td>
<td>&nbsp;<input type=submit value=" Insert ">&nbsp;</td>
</tr>

</form>

<form action=<? echo $PHP_SELF ?> method=post>
<tr bgcolor=#7070af>
<td><font color=#FFFFFF><b>New symlink</b></font></td>
<td><input type=text size=40 name=new_link>
    <input type=hidden name=sel_path value="<? echo $sel_path; ?>">
    <input type=hidden name=sort value="<? echo $sort; ?>">
    <input type=hidden name=action value="new_link">
    </td>
<td>&nbsp;<input type=submit value=" Insert ">&nbsp;</td>
</tr>

</form>
<td colspan=3 bgcolor=#dddddd>&nbsp;</td>
</table>


<table border=0 cellspacing=1 cellpadding=2 width=100%>
<tr bgcolor=#c0d0ef>
<td><b>&nbsp;<? echo $cur_path; ?></b></td>
<td align=right><b>Sort by: [ &nbsp; </b> <a href="<? echo "$PHP_SELF?sel_path=$sel_path&sort=name";?>"><b>Name</b></a>&nbsp; <b>|</b> &nbsp;<a href="<? echo "$PHP_SELF?sel_path=$sel_path&sort=path";?>"><b>Path</b></a> &nbsp; <b> ] &nbsp;</b> </td>
<td width=1% align=center><b>Path</b></td>
<td width=1% align=center><b>Link path</b></td>
<td width=1% align=center><b>Rename</b></td>
<td width=1% align=center><b>Del</b></td>
</tr>

<tr bgcolor=#ffffff>
<td colspan=2>&nbsp;<img src=<? echo $images_path; ?>folder.gif border=0> &nbsp; <a href="<? $temp=substr($sel_path,0,strlen($sel_path)-2); echo "$PHP_SELF?sel_path=$temp&sort=$sort" ?>"><font size=+2><b>..</b></font> (up one level)</a></td>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
<td>&nbsp;</td>
</tr>

<?
   $i=1;
   while($row=fetch_row($res)) {
   	$path=$row[0];
   	$link=$row[1];
   	$name=$row[2];

   	$depth=strlen($path);

        if ($i==0) $bgcolor='#ffffff';
        else $bgcolor='#dddddd';

        print "<tr bgcolor=$bgcolor>";

        $old_name=$name;
        $name=htmlspecialchars($name);
        if (substr($path,$depth-2,2)=='@@') {
        	$islink=1;
        	$name = '@ '.$name;
        	$link_name=get_link_name($link);
        	$name = $name."  > <a href=\"$PHP_SELF?sel_path=$link&sort=$sort\">$link_name</a>";
        } else $islink=0;

        $path=urlencode($path);

        $count=get_link_count($path);

   	if ($count) {
   		if ($islink) {
   			print "<td colspan=2>&nbsp;<img src=$images_path"."folder.gif border=0> &nbsp; $name</td>\n";
   		} else {
        		print "<td colspan=2>&nbsp;<img src=$images_path"."folder.gif border=0> &nbsp; <a href=$PHP_SELF?sel_path=$path&sort=$sort>$name</a></td>\n";
        	}
        } else {
        	if ($islink) {
        		print "<td colspan=2>&nbsp;<img src=$images_path"."unknown.gif border=0> &nbsp; $name</td>\n";
        	} else {
                	print "<td colspan=2>&nbsp;<img src=$images_path"."unknown.gif border=0> &nbsp; <a href=$PHP_SELF?sel_path=$path&sort=$sort>$name</a></td>\n";
                }
        }

        print "<td width=1% align=center>".urldecode($path)."</td>\n";

        if ($islink) {
        	print "<td><form action=$PHP_SELF method=post>".
                      "<input type=hidden name=action value=edit_link>".
                      "<input type=hidden name=sel_path value=\"$sel_path\">".
                      "<input type=hidden name=old_path value=\"$path\">".
                      "<input type=hidden name=sort value=\"$sort\">".
                      "<input type=submit value=\" Ok \">&nbsp;<input type=text size=10 name=new_path value=\"$link\"></td></form>\n";
        } else {
        	print "<td>&nbsp;</td>\n";
        }

        print "<td><form action=$PHP_SELF method=post>".
                   "<input type=hidden name=action value=rename>".
                   "<input type=hidden name=sel_path value=\"$sel_path\">".
                   "<input type=hidden name=old_path value=\"$path\">".
                   "<input type=hidden name=sort value=\"$sort\">".
                   "<input type=submit value=\" Ok \">&nbsp;<input type=text size=14 name=new_name value=\"$old_name\"></td></form>\n";

	print "<td align=center width=1%><form><input type=reset value=\"Del\" onClick=\"test('$PHP_SELF?action=del&sel_path=$path&sort=$sort', '$PHP_SELF?sel_path=$sel_path&sort=$sort')\"></td></form>";
        print "</tr>\n";
        $i=1-$i;
   }

   free_result($res);
?>
</table>

</font>

</body>
</html>
